<script>
import { onMounted, ref, watch } from 'vue'
import { useRoute } from 'vue-router'
import GitApi from '@/api/gitApi'

export default {
  name: 'GroupsBreadcrumbComponent',
  props: {
    route: {
      type: String,
      default: 'vendors',
    },
  },
  setup(props) {
    const route = useRoute()
    const breadcrumbs = ref([])
    const groupId = ref('')

    const getGroupId = groupIdParam => {
      const gitApi = new GitApi()
      if (props.route === 'vendors')
        groupId.value = groupIdParam === undefined ? gitApi.vendorId : groupIdParam
      else
        groupId.value = groupIdParam === undefined ? '' : groupIdParam
    }

    const loadBreadcrumbs = async () => {
      breadcrumbs.value = []

      const gitApi = new GitApi()
      try {
        let group = await fetchGroupWithParents(groupId.value, gitApi)
        while (group) {
          const menuItem = { text: group.name, to: { name: props.route, params: { id: group.id } }, active: false }

          breadcrumbs.value.unshift(menuItem)
          group = group.parent
        }
      }
      catch (error) {
        console.error('ERROR: loadBreadcrumbs: ', error)
      }
    }

    const fetchGroupWithParents = async (groupId, gitApi) => {
      const response = await gitApi.getGroup(groupId)
      const group = response.data
      if (group.parent_id)
        group.parent = await fetchGroupWithParents(group.parent_id, gitApi)

      return group
    }

    watch(() => route.params, () => {
      getGroupId(route.params.id)
      loadBreadcrumbs()
    }, { immediate: true })

    onMounted(() => {
      getGroupId(route.params.id)
      loadBreadcrumbs()
    })

    return {
      breadcrumbs,
      route,
    }
  },
}
</script>

<template>
  <VBreadcrumbs class="breadcrumb-wrapper">
    <VBreadcrumbsItem :to="{ name: route }">
      <VIcon class="align-text-top">
        mdi-folder
      </VIcon>
    </VBreadcrumbsItem>
    <VBreadcrumbsItem
      v-for="(item, index) in breadcrumbs"
      :key="item.text"
      :to="item.to"
      :active="item.active"
    >
      {{ item.text }}
    </VBreadcrumbsItem>
  </VBreadcrumbs>
</template>

<style scoped>
.breadcrumb-wrapper {
  margin: 16px;
}
</style>
